//+------------------------------------------------------------------+
//|             Expert by bobammax                                                   |
//|                                                                  |
//+------------------------------------------------------------------+
/* Expert base on time and price. This works best on the EUR, I have placed some trades on the 
   GBP, but find it too volitale to make decent profits. This must be run on a 60 min chart.
   The built in indicator will give you a clue as to what is going to happen next. Blue is an 
   uptrend, red is downtrend.
   The EA will look fora break out, example if you have a set of red bars, then when the next
   set of red bars in a row start, the expert will place a sell, the opposite for a buy.
   The indicator looks at the 4 hour time frame and compares it to a 1 hour time frame, and
   places trades off of that info. If you count the bars in the shaded area, there are 5 bars
   the 5th bar is used for final determaination of the color, your key to entry if the 
   next set lines up.It will place trades as to the direction of that bar.
   This has bee tested on the Metaquotes demo and on IBFX, both live and demo. It will not
    backtest on IBFX.Nor will it place a trade in IBFX, unless you remove the folder "symbolsets"
    and replace it with the same folder from Metaquotes. IBFX uses the "m" after the currency
    and this is keeping this EA and others from placing trades. You will still see the "m"
    on the charts, and it will show up on the trades. The symbolsets folder is a screwup on the 
    part of IBFX*/
    
   
   



#property copyright "bobammax"

#property link    ""   
bool indicator_buffers [2];
double indicator_color1= Aqua;
double indicator_color2= Red;
extern double lStopLoss = 25;
extern double sStopLoss = 25;
extern double lTrailingStop = 20;
extern double sTrailingStop = 20;
extern double TrailingStop = 25;
extern double Lots = 1;
extern double slip=3;
extern double TakeProfit= 150;    
extern double StopLoss= 25;
extern int NumberOfBarH6 = 100;     // quantity H6  candles  
extern int       CloseHour=19;
extern int       CloseMinute=55; 
extern int       OpenHour= 0700;
extern int       OpenMinute =05;
 int    ServerTimeZone = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {

  int i;

  for (i=0; i<NumberOfBarH6; i++) {
    ObjectDelete("H6Bar" + i);
  }
  for (i=0; i<NumberOfBarH6; i++) {
    ObjectCreate("H6Bar" + i, OBJ_RECTANGLE, 0, 0,0, 0,0);
  }
  Comment("");
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit()
{
  //the removal of the objects
  for (int i=0; i<NumberOfBarH6; i++) {
    ObjectDelete("H6Bar" + i);
  }
  Comment("");
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

 


  int start(){


  int sh6=0, sh1=0;
  double   oh6, ch6; // the prices of opening and closing of the candle

  datetime to6, tc6; // the time of opening and closing of the candle

  if (Period()!=60) Comment("Indicator i -H6-From-H1 support THE only equal to Ny");
  else {
    ch6 = Close[0];
    tc6 = Time[0];
    // we run on H6 to the candles
    while (sh6<NumberOfBarH6) {
      // we run on H1 to the candles
      if (TimeHour(Time[sh1])==0 || TimeHour(Time[sh1])==5
      || TimeHour(Time[sh1])==11 || TimeHour(Time[sh1])==17)
      {
      
        oh6 = Open[sh1-1];
        to6 = Time[sh1-1];
        ObjectSet("H6Bar"+sh6, OBJPROP_TIME1, to6);
        ObjectSet("H6Bar"+sh6, OBJPROP_PRICE1, oh6);
        ObjectSet("H6Bar"+sh6, OBJPROP_TIME2, tc6);
        ObjectSet("H6Bar"+sh6, OBJPROP_PRICE2, ch6);
        ObjectSet("H6Bar"+sh6, OBJPROP_STYLE, STYLE_SOLID);
        ObjectSet("H6Bar"+sh6, OBJPROP_BACK, True);
        if (oh6<ch6) ObjectSet("H6Bar"+sh6, OBJPROP_COLOR, indicator_color1);
        else ObjectSet("H6Bar"+sh6, OBJPROP_COLOR, indicator_color2);
        ch6 = Close[sh1];
        tc6 = Time[sh1];
        sh6++;
      }
      sh1++;
    }
  }
// T.**********************************************
// *** Trade in TimeZone                        ***
// ************************************************
   if(TimeHour(CurTime()) + ServerTimeZone >= 19 || TimeHour(CurTime()) + ServerTimeZone <= 0) {
      Comment ("\n","Current Time : ",TimeToStr(CurTime()),  );
      return(0);
   }  
   int cnt, ticket;  
   if(Bars<100){
      Print("bars less than 100");
      return(0);
   }
   if(lStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   if(sStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
    
    int total=OrdersTotal();
   if(total<1){
 
   
      if(AccountFreeMargin()<(1000*Lots)){
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);
      }

      if ((oh6>ch6&& to6> tc6 )){
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,slip,Ask-(StopLoss*Point),Ask+(TakeProfit*Point),0,0,Green);//OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-lStopLoss*Point,0, 0,Green);
         if(ticket>0){
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
         
         }
         else Print("Error opening BUY order : ",GetLastError());
         return(0);
      }

      if (( oh6<ch6 && to6 >tc6)){
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,slip,Bid+(StopLoss*Point),Bid-(TakeProfit*Point),0,0,Red);   //OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+sStopLoss*Point,0,0,Red);
         if(ticket>0) {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
          
         }
         else Print("Error opening SELL order : ",GetLastError());
         return(0);
      }
   }
  
   for(cnt=0;cnt<total;cnt++) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol()) {
         if(OrderType()==OP_BUY){

        
         }
         }
         if(TrailingStop>0)
{ 
     OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
     if((OrderType() == OP_BUY || OrderType() == OP_BUYSTOP) && 
(OrderSymbol()==Symbol()))
         {
            if(TrailingStop>0) 
              {                
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid- 
Point*TrailingStop,OrderTakeProfit(),0,Aqua);
                     return(0);
                    }
                 }
              }
          }
          }
     if((OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) && 
(OrderSymbol()==Symbol()))
         {
            if(TrailingStop>0)  
              {                
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if(OrderStopLoss()==0.0 || 
                     OrderStopLoss()>(Ask+Point*TrailingStop))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice
(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Aqua);
                     return(0);
                    }
                 }
              }
         }
         }
         }
   

 
           
   

 
           